#version 450

layout(location = 0) out vec4 out_color;

layout (binding = 0) uniform UniformBuffer {
	vec4 color;
	mat4 modelMatrix;
	mat4 modelMatrixForNormals;
	mat4 viewProjMatrix;
	vec4 cameraPosition;
	vec4 illumination;
	ivec4 userInput;
	
	float time;
    float impactX;
    float impactY;
    float pad3;
} ub_data;

layout(location = 1) in float vNormHeight;

void main() {
    vec4 deepBlue = vec4(0.0, 0.0, 0.8, 0.8);
    vec4 lightBlue = vec4(0.4, 0.6, 1.0, 0.8);
    out_color = mix(lightBlue, deepBlue, vNormHeight);
}