#version 450

layout (location = 0) in vec3 in_position;        
layout (location = 1) in vec3 in_normal;          
layout (location = 2) in vec2 in_texcoords;       

layout (binding = 0) uniform UniformBuffer {
    vec4 color;
    mat4 modelMatrix;
    mat4 modelMatrixForNormals;
    mat4 viewProjMatrix;
    vec4 cameraPosition;
    vec4 illumination; // ka, kd, ks, alpha
    ivec4 userInput;

    float time;
    float impactX;
    float impactY;
    float pad3;
} ub_data;

layout (binding = 1) uniform DirectionalLight {
    vec4 color;
    vec4 direction;
} dl_data;

layout (binding = 2) uniform PointLight {
    vec4 color;
    vec4 position;
    vec4 attenuation;
} pl_data;

layout (location = 0) out vec3 vs_positionOS;
layout (location = 1) out vec3 vs_normalOS;
layout (location = 2) out vec2 vs_texcoords;

void main() 
{
    // Just pass them through
    vs_positionOS = in_position;
    vs_normalOS   = in_normal;
    vs_texcoords  = in_texcoords;

    gl_Position = vec4(in_position, 1.0);
}
