#pragma once

#include <tiny_obj_loader.h>
#include <glm/glm.hpp>
#include <unordered_map>
#include <vector>
#include "ObjLoader.h"

namespace std {
    template<> struct hash<glm::vec2> {
        size_t operator()(const glm::vec2& v) const {
            return ((std::hash<float>()(v.x) ^ (std::hash<float>()(v.y) << 1)) >> 1);
        }
    };

    template<> struct hash<glm::vec3> {
        size_t operator()(const glm::vec3& v) const {
            size_t seed = 0;
            seed ^= std::hash<float>()(v.x) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
            seed ^= std::hash<float>()(v.y) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
            seed ^= std::hash<float>()(v.z) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
            return seed;
        }
    };

    template<> struct hash<Vertex> {
        size_t operator()(const Vertex& vertex) const {
            size_t seed = 0;
            seed ^= std::hash<glm::vec3>()(vertex.position) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
            seed ^= std::hash<glm::vec3>()(vertex.normal) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
            seed ^= std::hash<glm::vec2>()(vertex.texcoord) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
            return seed;
        }
    };
}